; Extended sprite on off switcher thing.
; This is an invisible sprite that when touched by a projectile (Like a baseball) will swap the on off as well as playing the on/off sound.
; Place this block above an on/off switch for it to actually make some sense.
; by TheBiob

print "MAIN ",pc
	PHB : PHK : PLB
		JSR OnOff
	PLB
	LDX $15E9
print "INIT ",pc
	RTL

OnOff:
	LDY #$00
	JSR SubOffScreen
	LDA $14			; \ 
	AND #$03		; | return every other frame
	ORA $9D			; | or if sprites are locked
	BNE ++			; /
	
	LDY #$07      ; change to 09 to include fireballs
-	LDA $170B,y
	BNE +
.next
	DEY : BPL -
++	RTS

+	CMP #$02
	BCC .next
	CMP #$0E
	BCS .next
	
	LDA $1632,x
	EOR $1779,y
	BNE .next
	
	LDX $170B,y
	LDA $171F,y
	CLC : ADC $02A4E7,x
	STA $00		; X low
	LDA $1733,y
	ADC #$00
	STA $08		; X high
	LDA $02A4FF,x
	STA $02		; Width
	LDA $1715,y
	CLC : ADC $02A4F3,x
	STA $01 	; Y low
	LDA $1729,y
	ADC #$00
	STA $09		; Y high
	LDA $02A50B,x
	STA $03		; Height
	
	LDX $15E9
	JSL $03B69F		; get sprite clipping
	JSL $03B72B		; check for contact
	BCC .next       ; return if no contact
	
	LDA #$00 : STA $170B,y
	
	LDA $E4,x
	STA $9A
	LDA $14E0,x
	STA $9B
	LDA $D8,x
	STA $98
	LDA $14D4,x
	STA $99
	
	LDA #$02
	PHB : PHA : PLB
	
		LDA #$05
		STA $04
		STZ $05
		STZ $06
		LDA #$13
		STA $07
		JSL $028752
	
	PLB
	
	JMP .next

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SubOffScreen - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Argument
; Y : type (#$00=X0, #$02=X1 ... #$0E=X7)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
SubOffScreen:
		LDA $15A0,x
		ORA $186C,x
		BEQ .Return2
		LDA $167A,x
		AND #$04
		BNE .Return2
		LDA $5B
		LSR A
		BCS .VerticalLevel
		LDA $D8,x
		ADC #$50
		LDA $14D4,x
		ADC #$00
		CMP #$02
		BCS .EraseSprite
		LDA $14E0,x
		XBA
		LDA $E4,x
		REP #$21
		ADC .AddTable,y
		SEC
		SBC $1A
		CMP .CmpTable,y
.Common		SEP #$20
		BCC .Return2
.EraseSprite	LDA $14C8,x
		CMP #$08
		BCC .KillSprite
		LDY $161A,x
		CPY #$FF
		BEQ .KillSprite
		LDA $1938,y
		AND #$FE
		STA $1938,y
.KillSprite	STZ $14C8,x
.Return2	RTS

.VerticalLevel	LDA $13
		LSR A
		BCS .CheckY
		LDA $14E0,x
		XBA
		LDA $E4,x
		REP #$21
		ADC.w #$0040
		CMP.w #$0280
		BRA .Common
.CheckY		LDA $14D4,x
		XBA
		LDA $D8,x
		REP #$20
		SBC $1C
		CLC
		ADC.w #$0070
		CMP.w #$01D0
		BRA .Common

.AddTable	dw $0040,$0040,$0010,$0070
		dw $0090,$0050,$0080,$FFC0
.CmpTable	dw $0170,$01E0,$01B0,$01D0
		dw $0230,$01B0,$0220,$0160